### R code from vignette source 'bardJSS.Rnw'

###################################################
### code chunk number 1: bardJSS.Rnw:95-96
###################################################
options(prompt = "R> ", continue = "+  ", width = 70, useFancyQuotes = FALSE, digits=3, warn=1)


###################################################
### code chunk number 2: bardJSS.Rnw:101-102
###################################################
.PngNo <- 0


###################################################
### code chunk number 3: afig (eval = FALSE)
###################################################
## .PngNo <- .PngNo + 1; file <- paste("Fig-bitmap-", .PngNo, ".png", sep="")
## png(file=file, width = 1200, height = 1200, pointsize = 24, bg = "white")


###################################################
### code chunk number 4: zfig (eval = FALSE)
###################################################
## dev.null <- dev.off()
## cat("\\begin{center}")
## cat("\\includegraphics{", file, "}\n\n", sep="")
## cat("\\end{center}")


###################################################
### code chunk number 5: zfigShort (eval = FALSE)
###################################################
## dev.null <- dev.off()
## cat("\\begin{center}")
## cat("\\includegraphics[viewport=200 400 1000 1000]{", file, "}\n\n", sep="")
## cat("\\end{center}")


###################################################
### code chunk number 6: zfigNarrow (eval = FALSE)
###################################################
## dev.null <- dev.off()
## cat("\\begin{center}")
## cat("\\includegraphics[viewport=250 0 1100 1200]{", file, "}\n\n", sep="")
## cat("\\end{center}")


###################################################
### code chunk number 7: bardJSS.Rnw:186-187
###################################################
 library("BARD")


###################################################
### code chunk number 8: bardJSS.Rnw:193-196
###################################################
 suffolk.map <- importBardShape(
      file.path(system.file("shapefiles", package = "BARD"),"suffolk_tracts")
 )


###################################################
### code chunk number 9: bardJSS.Rnw:210-212
###################################################
  kplan <- createKmeansPlan(suffolk.map, 5)
  rplan <- createRandomPlan(suffolk.map, 5)


###################################################
### code chunk number 10: rplot1 (eval = FALSE)
###################################################
##  plot(kplan, col = colorRampPalette(c("red","grey"))(5), axes = FALSE)


###################################################
### code chunk number 11: plot1a
###################################################
.PngNo <- .PngNo + 1; file <- paste("Fig-bitmap-", .PngNo, ".png", sep="")
png(file=file, width = 1200, height = 1200, pointsize = 24, bg = "white")
 plot(kplan, col = colorRampPalette(c("red","grey"))(5), axes = FALSE)
dev.null <- dev.off()
cat("\\begin{center}")
cat("\\includegraphics[viewport=200 400 1000 1000]{", file, "}\n\n", sep="")
cat("\\end{center}")


###################################################
### code chunk number 12: bardJSS.Rnw:254-255
###################################################
reportPlans(plans = list(kmeans= kplan, random1 = rplan))


###################################################
### code chunk number 13: rplot2 (eval = FALSE)
###################################################
##  plot(diff(kplan,rplan), plotall = TRUE, col = colorRampPalette(c("red","grey"))(5), axes = FALSE, horizontal=FALSE)


###################################################
### code chunk number 14: plot2a
###################################################
.PngNo <- .PngNo + 1; file <- paste("Fig-bitmap-", .PngNo, ".png", sep="")
png(file=file, width = 1200, height = 1200, pointsize = 24, bg = "white")
 plot(diff(kplan,rplan), plotall = TRUE, col = colorRampPalette(c("red","grey"))(5), axes = FALSE, horizontal=FALSE)
dev.null <- dev.off()
cat("\\begin{center}")
cat("\\includegraphics[viewport=250 0 1100 1200]{", file, "}\n\n", sep="")
cat("\\end{center}")


###################################################
### code chunk number 15: bardJSS.Rnw:769-774
###################################################
myScore<-function(plan,...)combineDynamicScores(plan,scorefuns=list(calcPopScore,calcLWCompactScore))

samples<-samplePlans(list(kplan), score.fun = myScore,  ngenplans = 20,
	 gen.fun = "createRandomPlan", refine.fun="refineNelderPlan", 
	refine.args = list(maxit = 200, dynamicscoring = TRUE))


###################################################
### code chunk number 16: rplot3 (eval = FALSE)
###################################################
## plot(summary(samples))


###################################################
### code chunk number 17: plot3a
###################################################
plot(summary(samples))


###################################################
### code chunk number 18: bardJSS.Rnw:962-980
###################################################
  myCombinedS <-function(plan,lastscore=NULL,...) {
  
    plast <- NULL
    ctlast <- NULL
    if (!is.null(lastscore)) {
      plast <- attr(lastscore, "plast")
      ctlast <- attr(lastscore, "ctlast")
    }
    
    pscore <- calcPopScore(plan, lastscore=plast, ...)
    ctscore <- calcContiguityScore(plan, lastscore = ctlast, ...)
    
    combined <- exp(ctscore) * attr(plan, "ndists") * 2 + exp(pscore)
    
    attr(combined, "plast") <- pscore
    attr(combined, "ctlast") <-ctscore
    return(combined)
  }


###################################################
### code chunk number 19: bardJSS.Rnw:1094-1114
###################################################
cs <- function(...) {
  mc <- substitute(list(...))
  if (length(mc) == 0) {
    return(list())
  }
  listlength <- 0
  for (i in seq(from = 2, length.out = length(mc) - 1)) {
      listlength <- listlength + length(eval.parent(mc[[i]]))
  }
  lastpos<-0
  retval<-vector(length = listlength, mode = "list")
  for (i in seq(from = 2, length.out = length(mc) - 1)) {
      tmp <- eval.parent(mc[[i]])
      for (j in seq(from = 1, length.out = length(tmp))) {
        retval[lastpos + j] <- tmp[j]
      }
      lastpos <- lastpos + length(tmp)
  }
  return(retval)
}


